
%% LOAD PROBLEM DATA

clear; close all; clc

% define the truss structure
% have a look at load_data.m to get a rough understanding
D = load_data;                          

m = numel(D.A);                         % number of bars
n = size(D.Coord,2);                    % number of nodes

% calculate stiffness matrix
% KLMI is a 3-dimensional matrix with K_i =  KLMI(:,:,i)
[KLMI, Le] = calculate_stiffness(D);

%% OPTIMIZE STRUCTURE
% TODO
% Formulate the problem here

% define area variables
x = sdpvar(m,1);                % this is a YALMIP variable     
...
    
% Define the objective function
obj = ...

% all constraints will be collected in this matrix
constr = [];

% This is the positive definiteness constraint
% construct matrix M as defined on the exercise sheet
% (M is not explictly defined on the sheet, but you should see which matrix
% it refers to)
M = ...
    
constr = [constr; M >= 0];

% you can add further constraints by appending them like this:
constr = [constr, CONSTR]; % (replace CONSTR by a suitable constraint)
...

% tell YALMIP to use SDPT3 as solver and pass some options
options = sdpsettings('solver', 'SDPT3','verbose',2,'sdpt3.maxit',100);

% tell YALMIP to actually solve the optimization problem
optimize(constr, obj, options);

% you can access the optimal values of your yalmip variables like this
xopt = double(x);

%% PLOT RESULTS

% plot structure
plot_structure(D, xopt')